<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html"/>

<xsl:variable name="x_indent" select="200"/>

<!-- ====================================================================== -->
<xsl:template match="/">
	<HTML>
	<HEAD>
	<TITLE>Data Dependent Balls Set Covering Machine Example</TITLE>
	</HEAD>
	<BODY>
		<h1>Set Covering Machine Visualization</h1>
		
		<div id="content">
			<h3>Balls</h3>

			<xsl:apply-templates select="debug_output/most_useful_ball"/>

			<xsl:apply-templates select="debug_output/initial"/>
		</div>
		
		<input 
			style="margin-top:100px"
			type="button" 
			value="Show Code" 
			onClick="document.all.code.value = (document.all.content.innerHTML)"/>
		<br/>
		<textarea name="code" cols="80" rows="40">
		</textarea>
	</BODY>
	</HTML>
</xsl:template>

<!-- ====================================================================== -->
<xsl:template match="initial">
		<xsl:apply-templates/>
</xsl:template>


<!-- ====================================================================== -->
<xsl:template match="data_points">
	<div>
		<h3>Data Points of <xsl:value-of select="@id"/></h3>
		<div id="@id">
			<xsl:apply-templates/>
		</div>
	</div>
</xsl:template>
	
<!-- ====================================================================== -->
<xsl:template match="point">
	Point at <xsl:value-of select="@x"/>,<xsl:value-of select="@y"/> <br/>

	<img>
	
		<xsl:attribute name="src">
			<xsl:choose>
				<xsl:when test="@is_positive=1">
					images/positive_point.png
				</xsl:when>
				<xsl:when test="@is_positive=0">
					images/negative_point.png
				</xsl:when>
				<xsl:otherwise>
				</xsl:otherwise>
			</xsl:choose>		
		</xsl:attribute>
		
		<xsl:attribute name="style">
			position: absolute;
			left: <xsl:value-of select="@x * (/debug_output/magnification) + (/debug_output/x_indent)" />;
			top: <xsl:value-of select="(/debug_output/y_indent) + (/debug_output/max_height - @y) * (/debug_output/magnification)" />;
		</xsl:attribute>
	</img>
</xsl:template>

<!-- ====================================================================== -->
<xsl:template match="most_useful_ball">

	Ball at <xsl:value-of select="ball/@center_x"/>,<xsl:value-of select="ball/@center_y"/> radius <xsl:value-of select="ball/@radius"/><br/>
	<img>
	
		<xsl:attribute name="src">
			<xsl:choose>
				<xsl:when test="ball/@is_positive=1">
					images/positive_ball.gif
				</xsl:when>
				<xsl:when test="ball/@is_positive=0">
					images/negative_ball.gif
				</xsl:when>
				<xsl:otherwise>
				</xsl:otherwise>
			</xsl:choose>		
		</xsl:attribute>
		<xsl:attribute name="style">
			position: absolute;
			left: <xsl:value-of select="(/debug_output/x_indent) +                              (ball/@center_x * (/debug_output/magnification)) - (ball/@radius * (/debug_output/magnification) )" />;
			top: <xsl:value-of  select="(/debug_output/y_indent) + ((/debug_output/max_height - ball/@center_y) * (/debug_output/magnification)) - (ball/@radius * (/debug_output/magnification) )" />;
			width: <xsl:value-of select="ball/@radius * (/debug_output/magnification) * 2" />;
			height: <xsl:value-of select="ball/@radius * (/debug_output/magnification) * 2" />
		</xsl:attribute>
	
	<!--
		<xsl:attribute name="style">
			position: absolute;
			left: <xsl:value-of select="(/debug_output/x_indent) + x_indent+(ball/@center_x - (ball/@radius div 2)) * (/debug_output/magnification)" />;
			top: <xsl:value-of select="(/debug_output/y_indent) + (/debug_output/max_height - ball/@center_y - (ball/@radius div 2)) * (/debug_output/magnification)" />;
			width: <xsl:value-of select="ball/@radius * (/debug_output/magnification)" />;
			height: <xsl:value-of select="ball/@radius * (/debug_output/magnification)" />

		</xsl:attribute>
		-->
		
	</img>
</xsl:template>

</xsl:stylesheet>
