def import_data(name_file_path, data_file_path, maximum_records=9999999999):

	# read the column names
	name_file=open(name_file_path, 'r')
	fieldlines = name_file.readlines()
	name_file.close()	
	field_value_replacement_pair_list = []
	include_field_list = []
	for fieldline in fieldlines:
		# take off leading and trailing spaces, etc..
		fieldline = fieldline.strip()
		# get the field name and the field data
		[include_field, field_maximum, field_name, field_data_string] = fieldline.split(":",3) 
		# break the field data into enumerated values
		field_values = field_data_string.split(",")
		field_value_replacement_pairs = []
		index=0
		for field_value in field_values:
			field_value=field_value.strip()
			field_value_replacement_pairs.append( (field_value,index) )
			index = index+1
		field_value_replacement_pair_list.append(field_value_replacement_pairs)
		include_field_list.append(int(include_field))
		#print field_name, field_value_replacement_pairs

	#print
	#print field_value_replacement_pair_list
	#print include_field_list
	#print
	
	data_file=open(data_file_path, 'r')
	datalines = data_file.readlines()
	data_file.close()
	final_data_list = []
	linecount = 0
	for dataline in datalines:
		bad_data = False
		raw_data_values = dataline.split(",")
		field_number=0
		revised_data_values = []
		for raw_data_value in raw_data_values:
			# skip over fields that were marked to be skipped
			if include_field_list[field_number] != 0:
				raw_data_value = raw_data_value.strip()
				made_sub = False
				# replace textual values with their specified replacement value
				for (value,replacement_value) in field_value_replacement_pair_list[field_number]:
					if raw_data_value==value:
						raw_data_value = replacement_value
						made_sub = True
						continue
				#if not(made_sub):
				try:
					raw_data_value = int(raw_data_value)
				except ValueError:
					# skip lines with invalid data (probably a "?")
					bad_data = True
					continue
				revised_data_values.append (raw_data_value)	
			field_number=field_number+1
		#print raw_data_values
		#print revised_data_values
		if not(bad_data):
			final_data_list.append( (revised_data_values[-1],revised_data_values[0:-1]))
		
		#print dataline
		linecount = linecount+1
		if linecount >= maximum_records:
			break
			
	return final_data_list
		
