class debug_object:
	
	def __init__ (self):
		self.debug_file_name = 'web/output.xml'
		point_offset_x=-2
		point_offset_y=-2
		self.debug_file=open(self.debug_file_name, 'w')
		self.debug_file.write('<?xml version="1.0" ?>\n')
		self.debug_file.write('<?xml-stylesheet type="text/xsl" href="databalls.xsl"?>\n')
		self.debug_file.write('<debug_output>\n')
		self.debug_file.write('<magnification>2</magnification>\n')
		self.debug_file.write('<max_height>110</max_height>\n')
		self.debug_file.write('<x_indent>350</x_indent>\n')
		self.debug_file.write('<y_indent>50</y_indent>\n')

	def close(self):
		self.debug_file.write('</debug_output>\n')
		self.debug_file.close()

	def debug_write_points(self, points, label):
		self.debug_file.write('\t<data_points id="' + label + '">\n')
		for (is_positive, [x, y]) in points:
			self.debug_file.write('\t\t<point is_positive="%d" x="%d" y="%d"/>\n' % (is_positive, x, y))
		self.debug_file.write('\t</data_points>\n')		

	def debug_write_initial_set(self, positive_examples_set, negative_examples_set):
		self.debug_file.write('\t<initial>\n')
		self.debug_write_points(positive_examples_set,"positive_examples_set")
		self.debug_write_points(negative_examples_set,"negative_examples_set")
		self.debug_file.write('\t</initial>\n')
	
	def debug_write_ball(self, ball, covered_points, error_points):
		self.debug_file.write('\t<most_useful_ball>\n')
		self.debug_file.write(ball.xml())
		self.debug_write_points(covered_points,"covered_points")
		self.debug_write_points(error_points,"error_points")
		self.debug_file.write('\t</most_useful_ball>\n')

DEBUG = 1
