#!/usr/bin/python

import sample_data
import debug
import data_dependent_balls
import buildSCM
import census_data
import distance_function

training_data = []
testing_data = []


# Example 1: Square
#training_data = sample_data.sample_data_set_square
#debug.DEBUG = 1

# Example 2: Party A
#training_data = sample_data.sample_data_set_party_1
#debug.DEBUG = 1

# Example 3: Party B
training_data = sample_data.sample_data_set_party_2
debug.DEBUG = 1


# Example 4: Census Data, 50 data points
#training_data = census_data.import_data("census/names.txt","census/data050.txt", 50)
#testing_data = census_data.import_data("census/names.txt","census/dataall.txt", 1000)
	

# Example 5: Census Data, 300 data points
#training_data = census_data.import_data("census/names.txt","census/data300.txt", 250)
#testing_data = census_data.import_data("census/names.txt","census/dataall.txt", 1000)
#debug.DEBUG = 0






def classify(point, feature_set, is_conjunction):
	sum = True
	if debug.DEBUG:
		print "[ 1",
	for feature in feature_set:
		feature_classification = feature.covers(point[1])
		#print repr(point), feature.specs(), feature_classification
		sum = sum and feature_classification
		if debug.DEBUG:
			if feature_classification:
				print "& 1",
			else:
				print "& 0",
	if debug.DEBUG:
		print "]  ",
	return sum



print
print "training data:"
print training_data

# create our balls
balls =  data_dependent_balls.makeBalls(training_data, distance_function.euclidian_distance)

# learn a set of features that cover the training data
learned_feature_set = buildSCM.buildSCM(training_data, 3, 10, balls)

print
print
print "learned feature set:"
for feature_id in range(len(learned_feature_set)):
	print repr(feature_id) + ":",
	learned_feature_set[feature_id].print_specs()

print
print 
print "Testing against training data:"
# test our answers
total=0
wrong=0
for point in training_data:
	print point,
	classification = classify(point, learned_feature_set, 1)
	if (bool(point[0])!=classification):
		flag = " WRONG"
		wrong=wrong+1
	else :
		flag = ""
	total=total+1
	print ">",bool(point[0]), classification,  flag
print "Error rate: " + repr(wrong) + "/" + repr(total) + " = " + repr((float(wrong)/float(total))*100.0)

print
print
print "Testing against test data:"
# test our answers
total=0
wrong=0
for point in testing_data:
	print point,
	classification = classify(point, learned_feature_set, 1)
	if (bool(point[0])!=classification):
		flag = " WRONG"
		wrong=wrong+1
	else :
		flag = ""
	total=total+1
	print ">",bool(point[0]), classification,  flag
print "Error rate: " + repr(wrong) + "/" + repr(total) + " = " + repr((float(wrong)/float(total))*100.0)


